	'.....................................................................
	'                                                                    .
	'    Lon Andr           KICKSBER.BAS               12.09.91        .
	'                                                                    .
	'    Rel. 1.60   (11. 06. 92)                                        .
	'                                                                    .
	'    Hauptprogramm zum berechnen der Monitor-Einheiten               .
	'                                                                    .
	'.....................................................................
	'
	ver$ = "1.60"

	' Farben :

	h% = 1	     '  Hintergrund  (blau)
	s% = 7	     '  Schrift      (weiss)
	b% = 2	     '  Balken       (grn)
	r% = 0	     '  Eingabeschr. (schwarz)
	g% = 4	     '  Cursor       (rot)

	$INCLUDE "KICKSLIB.BAS"

	zlen% = 20	 '  Lnge einer Zeile
	nmax% = 15	 '  Maximale Anzahl Zeilen
	lz% = 8 	 '  Zusatz links von jeder Zeile
	wahl1% = 1	 '  Auswahl Gert
	wahl2% = 1	 '  Auswahl Dosierungsart
	twahl% = 1	 '  Einstell-Technik = stehfeld
	weiter% = 10	 '  Nchster Schritt
	gerdos$ = " "    '  Eingelesene Dosis-Tabelle
	gertdk$ = " "    '  Eingelesene Tiefendosiskurve
	gerfak$ = " "    '  Eingelesene Faktoren
	maeq% = 30	 '  Maximale Anzahl Aequivalent-Feldgrssen
	mtdk% = 28	 '  Maximale Anzahl Tiefen bei TDK
	dosis = 0	 '  Dosis
	normz = 100	 '  Normierungszahl
	bezis = 100	 '  Bezugsisodose
	nenfa = 10	 '  Nennfeldgrsse A
	nenfb = 10	 '  Nennfeldgrsse B
	dbest = 20	 '  Anzahl Bestrahlungstage
	herdt = 0.5	 '  Herdtiefe
	outw = 100	 '  Output-Faktor


	DIM substr$(nmax%), astr$(nmax%), m$(12)
	DIM aeqd(maeq%), outp(maeq%), aeqt(maeq%), tdk(mtdk%,maeq%), dtdk(mtdk%)

	DATA "Januar","Februar","Mrz","April","Mai","Juni","Juli","August"
	DATA "September","Oktober","November","Dezember"

	FOR i% = 1 TO 12 :  READ m$(i%)  :  NEXT i%

	ON KEY(9) GOSUB schluss  :  KEY(9) ON

	adat$ = DATE$
	sdat$ = MID$(adat$,4,2) + ". " + m$(VAL(LEFT$(adat$,2)))
	sdat$ = sdat$ + " " + RIGHT$(adat$,4)
	xmons% = VAL(LEFT$(adat$,2))
	IF xmons% > 12 OR xmons% < 1 THEN
	   CLS
	   BEEP  :  BEEP
	   LOCATE 5,5  :  PRINT "Achtung: Datum-Format stimmt nicht"
	   LOCATE 7,5  :  PRINT adat$; "   Monate: ";xmons%
	   LOCATE 9,5  :  INPUT "         <Enter> eingeben", dummy$
	   STOP
	END IF

	DO UNTIL weiter% = 0

	'  Schritt Nr. 10 = Gerteauswahl
	   IF weiter% = 10 OR weiter% = 11 THEN
	      CALL gerles
	      weiter% = 20
	      CALL auswahl(wahl1%,weiter%)
	      IF wahl1% > 0 THEN
		 gerbez$ = substr$(wahl1%)
		 geraet$ = LEFT$(substr$(wahl1%),7)
		 lx% = LEN(geraet$)
		 FOR i% = lx% TO 1 STEP -1
		    ln% = LEN(geraet$) - 1
		    IF RIGHT$(geraet$,1) = " " THEN geraet$ = LEFT$(geraet$,ln%)
		 NEXT i%
	      END IF
	    END IF

	'  Schritt Nr. 20 = Auswahl der Dosierungsart
	   IF weiter% = 20 THEN
	      lmax% = 3  : lm% = 25  : tit1$ = "Bestrahlungsgert : " + geraet$
	      astr$(1) = "        Dosierung nach TPS-Plan          "
	      astr$(2) = "        Dosierung nach IRREG-Plan        "
	      astr$(3) = "        Dosierung nach Herdtiefe         "
	      CALL auswahl(wahl2%,weiter%)
	      IF weiter% > 10 THEN weiter% = weiter% + wahl2% + 10
	   END IF

	'  Schritt Nr. 31, 32 oder  33 = geraet.dos einlesen
	   IF weiter% = 31 OR weiter% = 32 OR weiter% = 33 THEN
	      IF geraet$ <> gerdos$ THEN
		 filn$ = geraet$ + ".DOS"
		 OPEN "i", #3, filn$
		 INPUT #3, naeqd%, fhdst, fad, hwz, dodays%, domons%, dojahr%
		 INPUT #3, einh$, colaa, colab, colba, colbb
		 fhdgr = fhdst
		 fhdpl = fhdst
		 FOR i% = 1 TO naeqd%
		    INPUT #3, aeqd(i%), outp(i%)
		 NEXT i%
		 CLOSE #3
		 IF fad = 0 THEN twahl% = 1
		 gerdos$ = geraet$
		 ' Berechnen der Zeitdiff Eichung bis heute
		 ddays% = VAL(MID$(adat$,4,2)) - dodays%
		 dmons% = VAL(LEFT$(adat$,2)) - domons%
		 dyear% = VAL(RIGHT$(adat$,2)) - dojahr%
		 difdays = ddays% + dmons% * 30.43 + dyear% * 365.25
	      END IF
	   END IF

	'  Schritt Nr. 33 = Einlesen der Tiefen-Dosis-Kurven
	   IF weiter% = 33 THEN
	      IF geraet$ <> gertdk$ THEN
		 filn$ = geraet$ + ".TDK"
		 OPEN "i", #3, filn$
		 INPUT #3, ntdk%, naeqt%

		 FOR i% = 1 TO naeqt%
		    INPUT #3, aeqt(i%)
		 NEXT  i%

		 FOR j% = 1 TO ntdk%
		    INPUT #3, dtdk(j%)
		    FOR i% = 1 TO naeqt%
		       INPUT #3, tdk(j%,i%)
		    NEXT i%
		 NEXT j%

		 CLOSE #3
		 gertdk$ = geraet$
	      END IF
	   END IF

	   IF weiter% > 30 AND weiter% < 40 THEN weiter% = weiter% + 10

	'   Schritt Nr. 41 a. =  Einstellungs-Technik erfragen
	   IF weiter% = 41 AND fad > 0 THEN
	      lmax% = 2  :  lm% = 25  :  tit1$ = "Einstll-Technik : "
	      IF twahl% = 2 THEN fhdgr = fhdst
	      astr$(1) = "                stehfeld                 "
	      astr$(2) = "              isozentrisch               "
	      CALL auswahl (twahl%,weiter%)
	   END IF

	'  Schritt Nr. 41 = Bestrahlungs-Daten bei TPS-Plnen
	   IF weiter% = 41 THEN
	      ausn% = 2
	      tit1$ = ""
	      CALL schirm(ver$)
	      COLOR r%,g%
	      LOCATE 25,1  :  PRINT SPACE$(80);
	      LOCATE 25,2
	      PRINT "Wert in: [  ]  mit <Enter> bernehmen oder neuen Wert ";
	      PRINT "eingeben.         ";
	      COLOR s%,h%
	      LOCATE 7, 6   :  PRINT "Bestrahlungsgert : ";
	      LOCATE 7, 30  :  COLOR r%, b%  :
	      PRINT " ";gerbez$;" "  :  COLOR s%, h%
	      CALL wertinp (dosis,"Dosis pro Feld (cGy) :",9,9)
	      CALL wertinp (normz,"Normierungszahl (%)  :",11,11)
	      CALL wertinp (bezis,"Bezugsisodose   (%)  :",13,11)
	      IF twahl% = 1 THEN
		 CALL wertinp (fhdgr,"FHD am Gert    (cm) :",13,13)
		 CALL wertinp (fhdpl,"FHD nach TPS    (cm) :",15,13)
		 abstf = fhdpl*fhdpl / (fhdgr*fhdgr)
	      ELSE
		 fhdgr = fad
		 fhdpl = fad
		 IF fad <> fhdst THEN
		    CALL wertinp (fhdgr,"FAD nach TPS    (cm) :",13,13)
		 ELSE
		    LOCATE 13, sp1%  :	PRINT "FAD             (cm) :";
		    COLOR r%, b%
		    LOCATE 13, sp2%  :	PRINT USING " ###.# "; fad;
		    COLOR s%, h%
		 END IF
		 abstf = 1
	      END IF
	      aeqber% = 0  :  altw = nenfa
	      IF twahl% = 2 AND fad <> fhdst THEN
		 CALL wertinp (nenfa,"Feldgr. A im isoz.   :",15,15)
		 hauta = nenfa
	      ELSE
		 CALL feldinp (nenfa,hauta,"A",fhdgr,fhdst,15)
	      END IF
	      IF altw = 0 OR altw <> nenfa THEN aeqber% = 1
	      altw = nenfb
	      IF twahl% = 2 AND fad <> fhdst THEN
		 CALL wertinp (nenfb,"Feldgr. B im isoz.   :",17,17)
		 hautb = nenfb
	      ELSE
		 CALL feldinp (nenfb,hautb,"B",fhdgr,fhdst,17)
	      END IF
	      IF altw = 0 OR altw <> nenfb THEN aeqber% = 1
	      IF aeqfeld = 0 OR aeqber% = 1 THEN
		 aeqfeld = 2 * hauta * hautb / (hauta + hautb)
	      END IF
	      CALL wertinp (aeqfeld,"Aequivalent     (cm) :",19,19)
	      aeqfs = aeqfeld * fhdst / fhdgr
	      CALL outpint (aeqfeld,outw)

	      IF hwz > 0 THEN
		 CALL wertinp (dbest,"vorauss. Dauer (Tage):",21,19)
		 outw = outw * EXP(-(difdays+dbest*0.5)*0.69315/hwz)
	      END IF
	      LOCATE 21, sp1%  :  PRINT "OUTPUT-FAKTOR        :";
	      COLOR r%, b%
	      IF outw > 10 THEN
		 LOCATE 21, sp2%  :  PRINT USING " ###.# "; outw;
	      ELSE
		 LOCATE 21, sp2%  :  PRINT USING " #.### "; outw;
	      END IF
	      COLOR s%, h%
	      LOCATE 21, sp4%  :  PRINT "Alles korrekt [ja] "
	      COLOR r%, g%  :  LOCATE 21, sp5%	:  PRINT "        "
	      LOCATE 21, sp5%  :  INPUT " ",ja$
	      IF ja$ = "" OR ja$ = "ja" OR ja$ = "JA" THEN weiter% = 51
	      COLOR s%, h%
	   END IF

	'  Schritt Nr. 42 = Bestrahlungs-Daten bei IRREG-Plnen
	   IF weiter% = 42 THEN
	      ausn% = 1
	      keilf = 1
	      tit1$ = ""
	      CALL schirm(ver$)
	      COLOR r%,g%
	      LOCATE 25,1  :  PRINT SPACE$(80);
	      LOCATE 25,2
	      PRINT "Wert in: [  ]  mit <Enter> bernehmen oder neuen Wert ";
	      PRINT "eingeben.         ";
	      COLOR s%,h%
	      LOCATE 7, 6   :  PRINT "Bestrahlungsgert : ";
	      LOCATE 7, 30  :  COLOR r%, b%  :
	      PRINT " ";gerbez$;" "  :  COLOR s%, h%
	      normz = 100
	      CALL wertinp (dosis,"Dosis pro Feld (cGy) :",9,9)
	      CALL wertinp (bezis,"Rel.Dosis im Pkt.(%) :",11,11)
	      CALL wertinp (outw,"Dosisleist. im Pkt.  :",13,11)
	      CALL wertinp (fhdgr,"FHD am Gert    (cm) :",13,13)
	      CALL wertinp (fhdpl,"FHD nach IRREG  (cm) :",15,13)
	      abstf = fhdpl*fhdpl / (fhdgr*fhdgr)
	      aeqber% = 0  :  altw = nenfa
	      CALL feldinp (nenfa,hauta,"A",fhdgr,fhdst,15)
	      CALL feldinp (nenfb,hautb,"B",fhdgr,fhdst,17)
	      aeqfs = nenfa * nenfb * 2 / (nenfa + nenfb)
	      aeqfeld = 0
	      COLOR s%, h%
	      LOCATE 21, sp4%  :  PRINT "Alles korrekt [ja] "
	      COLOR r%, g%  :  LOCATE 21, sp5%	:  PRINT "        "
	      LOCATE 21, sp5%  :  INPUT " ",ja$
	      ausn% = 1
	      IF ja$ = "" OR ja$ = "ja" OR ja$ = "JA" THEN weiter% = 60
	      COLOR s%, h%
	   END IF

	'  Schritt Nr. 43 = Bestrahlungs-Daten bei Dosierung nach Herdtiefe
	   IF weiter% = 43 THEN
	      ausn% = 2
	      tit1$ = ""
	      CALL schirm(ver$)
	      COLOR r%,g%
	      LOCATE 25,1  :  PRINT SPACE$(80);
	      LOCATE 25,2
	      PRINT "Wert in: [  ]  mit <Enter> bernehmen oder neuen Wert ";
	      PRINT "eingeben.         ";
	      COLOR s%,h%
	      LOCATE 7, 6   :  PRINT "Bestrahlungsgert : ";
	      LOCATE 7, 30  :  COLOR r%, b%  :
	      PRINT " ";gerbez$;" "  :  COLOR s%, h%
	      CALL wertinp (dosis,"Dosis pro Feld (cGy) :",9,9)
	      normz = 100
	      CALL wertinp (herdt,"Herd-Tiefe      (cm) :",11,11)
	      CALL wertinp (fhdgr,"FHD am Gert    (cm) :",13,13)
	      abstf = fhdst*fhdst / (fhdgr*fhdgr)
	      aeqber% = 0  :  altw = nenfa
	      CALL feldinp (nenfa,hauta,"A",fhdgr,fhdst,15)
	      IF altw = 0 OR altw <> nenfa THEN aeqber% = 1
	      altw = nenfb
	      CALL feldinp (nenfb,hautb,"B",fhdgr,fhdst,17)
	      IF altw = 0 OR altw <> nenfb THEN aeqber% = 1
	      IF aeqfeld = 0 OR aeqber% = 1 THEN
		 aeqfeld = 2 * hauta * hautb / (hauta + hautb)
	      END IF
	      CALL wertinp (aeqfeld,"Aequivalent     (cm) :",19,19)
	      aeqfs = aeqfeld * fhdst / fhdgr
	      CALL herdproz (herdt, aeqfeld, bezis)
	      LOCATE 11, sp4%  :  PRINT "Bezugsisodose   (%)  :";
	      COLOR r%, b%
	      LOCATE 11, sp5%  :  PRINT USING " ###.# "; bezis;
	      COLOR s%, h%

	      CALL outpint (aeqfeld,outw)

	      IF hwz > 0 THEN
		 CALL wertinp (dbest,"vorauss. Dauer (Tage):",21,19)
		 outw = outw * EXP(-(difdays+dbest)*0.69315/hwz)
	      END IF
	      LOCATE 21, sp1%  :  PRINT "OUTPUT-FAKTOR        :";
	      COLOR r%, b%
	      IF outw > 10 THEN
		 LOCATE 21, sp2%  :  PRINT USING " ###.# "; outw;
	      ELSE
		 LOCATE 21, sp2%  :  PRINT USING " #.### "; outw;
	      END IF
	      COLOR s%, h%
	      LOCATE 21, sp4%  :  PRINT "Alles korrekt [ja] "
	      COLOR r%, g%  :  LOCATE 21, sp5%	:  PRINT "        "
	      LOCATE 21, sp5%  :  INPUT " ",ja$
	      IF ja$ = "" OR ja$ = "ja" OR ja$ = "JA" THEN weiter% = 53
	      COLOR s%, h%
	   END IF

	'  Schritt Nr. 51 resp. Nr. 53 = Keilfaktor bestimmen
	   IF weiter% = 51 OR weiter% = 53 THEN
	      weiter% = 60
	      OPEN "i", #3, geraet$+".KEI"
	      ausn% = 2
	      keilf = 1.
	      CALL faktor (aeqfs, keilf, weiter%)
	   END IF

	'  Schritt Nr. 60 = Absorbtionsfaktoren fr Blockhalterungen
	   IF weiter% = 60 THEN
	      OPEN "i", #3, geraet$ + ".BLO"
	      weiter% = 70
	      blockf = 1.
	      CALL faktor (aeqfs, blockf, weiter%)
	      ausn% = 2
	   END IF

	'  Schritt Nr. 70 = Absorbtionsfaktoren fr Gerteparameter
	   IF weiter% = 70 THEN
	      OPEN "i", #3, geraet$ + ".GER"
	      geraetf = 1.
	      weiter% = 80
	      CALL faktor (aeqfs, geraetf, weiter%)
	   END IF

	'  Schritt Nr. 80 = Absorbtionsfaktoren fr Lagerungshilfen
	   IF weiter% = 80 THEN
	      OPEN "i", #3, geraet$ + ".LAG"
	      laghilf = 1.
	      weiter% = 90
	      CALL faktor (aeqfs, laghilf, weiter%)
	   END IF

	'  Schritt Nr. 90 = Anzeigen der berechneten Werte
	   IF weiter% = 90 THEN
	      maxdos = dosis * 100  / bezis * 100 / normz
	      monitor = maxdos/outw/abstf/geraetf/blockf/laghilf/keilf
	      IF aeqfeld = 0 THEN monitor = dosis/outw/abstf/geraetf/blockf/laghilf
	      tit1$ = ""
	      CALL schirm (ver$)
	      LOCATE  6,  6  :	PRINT "Bezugsisodose     : "  :  COLOR r%, b%
	      LOCATE  6, 27  :	PRINT USING " ###.# "; bezis :  COLOR s%, h%
	      LOCATE  6, 37  :	PRINT "%"
	      LOCATE  8,  6  :	PRINT "Normierungszahl   : "  :  COLOR r%, b%
	      LOCATE  8, 27  :	PRINT USING " ###.# "; normz :  COLOR s%, h%
	      LOCATE  8, 37  :	PRINT "%"
	      LOCATE 10,  6  :	PRINT "Aequivalent       : "  :  COLOR r%, b%
	      IF aeqfeld > 0 THEN
		 LOCATE 10, 27	:  PRINT USING " ###.# "; aeqfeld :  COLOR s%, h%
		 LOCATE 10, 37	:  PRINT "cm"
	      ELSE
		 LOCATE 10, 27	:  PRINT " IRREG "
		 COLOR s%, h%
	      END IF

	      LOCATE 12,  6  :	PRINT "Output-Faktor     : "  :  COLOR r%, b%
	      IF outw > 10 THEN
		 LOCATE 12, 27	:  PRINT USING " ###.# "; outw  :  COLOR s%, h%
	      ELSE
		 LOCATE 12, 27	:  PRINT USING " #.### "; outw  :  COLOR s%, h%
	      END IF
	      LOCATE 12, 37  :	PRINT "cGy/";einh$
	      LOCATE 14,  6  :	PRINT "Abstands-Faktor   : "  :  COLOR r%, b%
	      LOCATE 14, 27  :	PRINT USING " #.### "; abstf :  COLOR s%, h%
	      LOCATE 16,  6  :	PRINT "Absorbtionsfakt.  : "  :  COLOR r%, b%
	      LOCATE 16, 27  :	PRINT USING " #.### "; blockf
	      LOCATE 16, 35  :	PRINT USING " #.### "; geraetf
	      LOCATE 16, 43  :	PRINT USING " #.### "; laghilf :  COLOR s%, h%
	      LOCATE 18,  6  :	PRINT "Keil-Faktor       : "  :  COLOR r%, b%
	      LOCATE 18, 27  :	PRINT USING " #.### "; keilf :  COLOR s%, h%
	      LOCATE 20,  6  :	PRINT "Dosis pro Feld    : "  :  COLOR r%, b%
	      LOCATE 20, 27  :	PRINT USING " ###.# "; dosis :  COLOR s%, h%
	      LOCATE 20, 37  :	PRINT "cGy"
	      LOCATE 22,  6  :	PRINT "Monitor-Einheiten : "  :  COLOR r%, b%
	      IF monitor < 100. THEN
		 LOCATE 22, 27	:  PRINT USING " ##.## "; monitor :  COLOR s%, h%
	      ELSE
		 LOCATE 22, 27	:  PRINT USING " ###.# "; monitor :  COLOR s%, h%
	      END IF
	      LOCATE 22, 37  :	PRINT einh$
	      COLOR r%,g%
	      LOCATE 25,1  :  PRINT SPACE$(80);
	      LOCATE 25,2
	      PRINT " Weiter  mit:  <Enter>  ";
	      COLOR s%,h%
	      LOCATE 6, 55  :  PRINT "Max-Dosis : ";  :  COLOR r%, b%
	      LOCATE 6, 68  :  PRINT USING " ###.# ";maxdos  :  COLOR s%, h%
	      cola = colaa * nenfa + colab
	      LOCATE 10, 55  :	PRINT "Coli. A   : ";  :  COLOR r%, b%
	      LOCATE 10, 68  :	PRINT USING " ###.# ";cola    :  COLOR s%, h%
	      colb = colba * nenfb + colbb
	      LOCATE 12, 55  :	PRINT "Coli. B   : ";  :  COLOR r%, b%
	      LOCATE 12, 68  :	PRINT USING " ###.# ";colb    :  COLOR s%, h%
	      CALL zusrahmen (52,8)
	      LOCATE 24, 3  :  INPUT " ", dummy$
	   END IF

	   IF weiter% > 80 THEN weiter% = 10

	LOOP


     schluss:
	STOP
